import pyodbc
from datetime import datetime

class logsManager:
    
    def __init__(self, server, database, username, password):
        self.conn_str = 'DRIVER={ODBC Driver 17 for SQL Server};SERVER=' + server + ';DATABASE=' + database + ';UID=' + username + ';PWD=' + password

    def insertHost(self, hostname, ipAddress):
        
        try:
            
            conn = pyodbc.connect(self.conn_str)
            cursor = conn.cursor()
            cursor.execute("SELECT COUNT(*) FROM monutil_hosts WHERE hostname = ?", hostname)
            
            if cursor.fetchone()[0] == 0:
                
                cursor.execute("INSERT INTO monutil_hosts (hostname, ipAddress) VALUES (?, ?)", hostname, ipAddress)
                conn.commit()

            else:

                cursor.execute("UPDATE monutil_hosts SET ipAddress = ? WHERE hostname = ?", ipAddress, hostname)

        except pyodbc.Error as ex:
            
            print("Error inserting data: {}".format(str(ex)))

    def insertHostLog(self, hostname, ipAddress, log_time, cpu, memory):
        
        try:
            
            self.insertHost(hostname, ipAddress)
            
            conn = pyodbc.connect(self.conn_str)
            cursor = conn.cursor()

            cursor.execute("INSERT INTO monutil_hostlogs (hostname, logTime, cpu, memory) VALUES (?, ?, ?, ?)", hostname, log_time, cpu, memory)
            conn.commit()
            conn.close()

        except pyodbc.Error as ex:
            
            print("Error inserting data: {}".format(str(ex)))

    def insertURLLog(self, hostname, ipAddress, log_time, url, responseTime):

        try:

            self.insertHost(hostname, ipAddress)

            conn = pyodbc.connect(self.conn_str)
            cursor = conn.cursor()

            cursor.execute("INSERT INTO monutil_urlLogs (hostname, url, logTime, responseTime) VALUES (?, ?, ?, ?)", hostname, url, log_time, responseTime)

            conn.commit()
            conn.close()

        except pyodbc.Error as ex:

            print("Error inserting data into monutil_urlLogs:", ex)
